#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	
	
	for (int i = 0; i < 200; i++){
		particle myParticle;
		myParticle.setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
		particles.push_back(myParticle);
	}
	
	for (int i = 0; i < 200; i++){
		particle myParticle2;
		myParticle2.setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
		particles2.push_back(myParticle2);
	}
	
	bRepel		= true;
	radius		= 10;
	strength	= 0.1f; 
	
	
	radius2		= 140;
	strength2	= 1.9f; 
	
	
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
	}
	
	
	// zach's way !!!!
	for (int i = 0; i < particles.size(); i++){
		for (int j = 0; j < i; j++){
			if (bRepel){
				particles[i].addRepulsionForce(particles[j], radius, strength);
			} else {
				particles[i].addAttractionForce(particles[j], radius, strength);
			}
		}
	}
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].addDampingForce();
		particles[i].update();
	}
	
	
	
	/////////////////////////////////////////////////////////////
	
	
	for (int i = 0; i < particles2.size(); i++){
		particles2[i].resetForce();
	}
	
	
	// zach's way !!!!
	for (int i = 0; i < particles2.size(); i++){
		for (int j = 0; j < i; j++){
			if (bRepel){
				particles2[i].addRepulsionForce(particles2[j], radius2, strength2);
			} else {
				particles2[i].addAttractionForce(particles2[j], radius2, strength2);
			}
		}
	}
	
	for (int i = 0; i < particles2.size(); i++){
		particles2[i].addDampingForce();
		particles2[i].update();
	}
}

//--------------------------------------------------------------
void testApp::draw(){
	
	ofEnableAlphaBlending();
	//ofSetColor(0,130,130, 200);
	
	//ofSetColor(0x000000);
	
	for (int i = 0; i < particles.size(); i++){
		
			ofSetColor(255,255,255, 200);
	
		particles[i].draw();
	}
	


	
	for (int i = 0; i < particles2.size(); i++){
			ofSetColor(0,0,0, 200);
	particles2[i].draw();
		
	
	}
	
	
	for (int i = 0; i < particles2.size(); i++){
		ofSetColor(130,0,130, 200);

		ofLine(particles[i].pos.x, particles[i].pos.y, particles2[i].pos.x, particles2[i].pos.y);
	
	}
	
	
	
	
	
	
/*	string reportString =	"(space) = reset\n(a/s) strength = " + ofToString(strength) + 
							"\n(z/x) radius = " + ofToString(radius) + 
							"\n(r) toggle mode = " + (bRepel ? "repelling" : "attracting");
	
	ofSetColor(40,40,0);
	ofRect(10,10,300,80);
	ofSetColor(255,255,255);
	ofDrawBitmapString(reportString, 30, 30);*/
	
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	switch (key){
			
		case ' ':
			// reposition everything: 
			for (int i = 0; i < particles.size(); i++){
				particles[i].setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
			}
			break;
		case 'a':
			strength += 0.02f;
			break;
		case 's':
			strength -= 0.02f;
			if (strength <= 0) strength = 0.02f;
			break;
		case 'z':
			radius += 5.0f;
			break;
		case 'x':
			radius -= 5.0f;
			if (radius <= 0) radius = 5.0f;
			break;
		case 'r':
			bRepel = !bRepel;
			break;
	}
	
	
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	particles.erase(particles.begin());
	particle myParticle;
	myParticle.setInitialCondition(x,y,0,0);
	particles.push_back(myParticle);
	
	
	
	particles2.erase(particles2.begin());
	particle myParticle2;
	myParticle2.setInitialCondition(x,y,0,0);
	particles2.push_back(myParticle2);
	

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	
	particles.erase(particles.begin());
	particle myParticle;
	myParticle.setInitialCondition(x,y,0,0);
	particles.push_back(myParticle);
	
	
	
	particles2.erase(particles2.begin());
	particle myParticle2;
	myParticle2.setInitialCondition(x,y,0,0);
	particles2.push_back(myParticle2);
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}
